/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Automatically Converted",
    "Transitions"
  ],
  "DESCRIPTION" : "Automatically converted from https:\/\/www.shadertoy.com\/view\/Xl3BDn by hezhk3.  see https:\/\/gl-transitions.com\/editor\/windowslice",
  "INPUTS" : [
    {
      "TYPE" : "image",
      "NAME" : "inputImage"
    },
    {
      "TYPE" : "image",
      "NAME" : "iChannel0"
    },
    {
      "NAME" : "DirectionX",
      "TYPE" : "float",
      "MAX" : 1,
      "DEFAULT" : 0,
      "MIN" : 0
    },
    {
      "NAME" : "DirectionY",
      "TYPE" : "float",
      "MAX" : 1,
      "DEFAULT" : 1,
      "MIN" : 0
    }
  ],
  "ISFVSN" : "2"
}
*/


#define texture2D(a,b) texture(a,b)

#define textureCoordinate (gl_FragCoord.xy / RENDERSIZE.xy)
#define textureCoordinate2 (gl_FragCoord.xy / RENDERSIZE.xy)

#define progress fract(TIME*0.5)
#define ratio (RENDERSIZE.x / RENDERSIZE.y)

#define REV_VEC2(p) vec2(p.x, 1.0 - p.y)
#define getFromColor(coord) IMG_NORM_PIXEL(inputImage, REV_VEC2(coord))
#define getToColor(coord) IMG_NORM_PIXEL(iChannel0, REV_VEC2(coord))

vec2 direction= vec2(DirectionX, DirectionY); // = vec2(0.0, 1.0)

vec4 transition (vec2 uv) {
  vec2 p = uv - progress * sign(direction);
  vec2 f = fract(p);
  return mix(
    getToColor(f),
    getFromColor(f),
    step(0.0, p.y) * step(p.y, 1.0) * step(0.0, p.x) * step(p.x, 1.0)
  );

}
void main() {



    gl_FragColor = transition(REV_VEC2(textureCoordinate));
}
