/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Automatically Converted",
    "Transitions"
  ],
  "DESCRIPTION" : "Automatically converted from https:\/\/www.shadertoy.com\/view\/MlXGzf by aiekick.  Im not the author of this code. I have just adapted it to ShaderToy.\nCode from here : [url=https:\/\/glsl.io\/]Glsl.io[\/url]",
  "INPUTS" : [
    {
      "TYPE" : "image",
      "NAME" : "inputImage"
    },
    {
      "TYPE" : "image",
      "NAME" : "iChannel0"
    },
    {
			"LABEL": "Mouse X",
			"NAME": "mX",
			"TYPE": "float",
			"DEFAULT": 0.5,
			"MIN": 0.0,
			"MAX": 1.0
		},
		{
			"LABEL": "Mouse Y",
			"NAME": "mY",
			"TYPE": "float",
			"DEFAULT": 0.5,
			"MIN": 0.0,
			"MAX": 1.0
		},
		{
			"LABEL": "Mouse Z",
			"NAME": "mZ",
			"TYPE": "float",
			"DEFAULT": 0.5,
			"MIN": 0.0,
			"MAX": 1.0
		},
		{
			"LABEL": "Mouse W",
			"NAME": "mW",
			"TYPE": "float",
			"DEFAULT": 0.5,
			"MIN": 0.0,
			"MAX": 1.0
		}

  ]
}
*/

vec4 iMouse = vec4(mX*RENDERSIZE.x, mY*RENDERSIZE.y, mZ*RENDERSIZE.x, mW*RENDERSIZE.y);

#define from iChannel0
#define to inputImage
#define resolution (RENDERSIZE.xy)

float progress;
float reflection = .4;
float perspective = .2;
float depth = 3.;
 
const vec4 black = vec4(0.0, 0.0, 0.0, 1.0);
const vec2 boundMin = vec2(0.0, 0.0);
const vec2 boundMax = vec2(1.0, 1.0);
 
bool inBounds (vec2 p) {
  return all(lessThan(boundMin, p)) && all(lessThan(p, boundMax));
}
 
vec2 project (vec2 p) {
  return p * vec2(1.0, -1.2) + vec2(0.0, -0.02);
}
 
vec4 bgColor (vec2 p, vec2 pfr, vec2 pto) {
  vec4 c = black;
  pfr = project(pfr);
  if (inBounds(pfr)) {
    c += mix(black, IMG_NORM_PIXEL(iChannel0, pfr), reflection * mix(1.0, 0.0, pfr.y));
  }
  pto = project(pto);
  if (inBounds(pto)) {
    c += mix(black, IMG_NORM_PIXEL(inputImage, pto), reflection * mix(1.0, 0.0, pto.y));
  }
  return c;
}
 
void main() {

  progress = sin(TIME*.5)*.5+.5;
  vec2 p = gl_FragCoord.xy / resolution.xy;
  if (iMouse.z>0.) progress = iMouse.x/RENDERSIZE.x;
  vec2 pfr, pto = vec2(-1.);
 
  float size = mix(1.0, depth, progress);
  float persp = perspective * progress;
  pfr = (p + vec2(-0.0, -0.5)) * vec2(size/(1.0-perspective*progress), size/(1.0-size*persp*p.x)) + vec2(0.0, 0.5);
 
  size = mix(1.0, depth, 1.-progress);
  persp = perspective * (1.-progress);
  pto = (p + vec2(-1.0, -0.5)) * vec2(size/(1.0-perspective*(1.0-progress)), size/(1.0-size*persp*(0.5-p.x))) + vec2(1.0, 0.5);
 
  bool fromOver = progress < 0.5;
 
  if (fromOver) {
    if (inBounds(pfr)) {
      gl_FragColor = IMG_NORM_PIXEL(iChannel0, pfr);
    }
    else if (inBounds(pto)) {
      gl_FragColor = IMG_NORM_PIXEL(inputImage, pto);
    }
    else {
      gl_FragColor = bgColor(p, pfr, pto);
    }
  }
  else {
    if (inBounds(pto)) {
      gl_FragColor = IMG_NORM_PIXEL(inputImage, pto);
    }
    else if (inBounds(pfr)) {
      gl_FragColor = IMG_NORM_PIXEL(iChannel0, pfr);
    }
    else {
      gl_FragColor = bgColor(p, pfr, pto);
    }
  }
}
