/*
{
  "IMPORTED" : [

  ],
  "CATEGORIES" : [
    "Automatically Converted",
    "Transitions"
  ],
  "DESCRIPTION" : "Automatically converted from https:\/\/www.shadertoy.com\/view\/Xl3BDn by hezhk3.  see https:\/\/gl-transitions.com\/editor\/windowslice",
  "INPUTS" : [
    {
      "TYPE" : "image",
      "NAME" : "inputImage"
    },
    {
      "TYPE" : "image",
      "NAME" : "iChannel0"
    }
  ],
  "ISFVSN" : "2"
}
*/


#define texture2D(a,b) texture(a,b)

#define textureCoordinate (gl_FragCoord.xy / RENDERSIZE.xy)
#define textureCoordinate2 (gl_FragCoord.xy / RENDERSIZE.xy)

#define progress fract(TIME*0.5)
#define ratio (RENDERSIZE.x / RENDERSIZE.y)

#define REV_VEC2(p) vec2(p.x, 1.0 - p.y)
#define getFromColor(coord) IMG_NORM_PIXEL(inputImage, REV_VEC2(coord))
#define getToColor(coord) IMG_NORM_PIXEL(iChannel0, REV_VEC2(coord))

 vec2 squaresMin = vec2(20); // minimum number of squares (when the effect is at its higher level)
 int steps = 50 ; // zero disable the stepping

float d = min(progress, 1.0 - progress);
float dist = steps>0 ? ceil(d * float(steps)) / float(steps) : d;
vec2 squareSize = 2.0 * dist / vec2(squaresMin);

vec4 transition(vec2 uv) {
  vec2 p = dist>0.0 ? (floor(uv / squareSize) + 0.5) * squareSize : uv;
  return mix(getFromColor(p), getToColor(p), progress);
}

void main() {



    gl_FragColor = transition(REV_VEC2(textureCoordinate));
}
